﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SpellCheck_DataBound
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            Load += Form1_Load;
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            DataTable dt = new DataTable();
            string connectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" +
                         System.IO.Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments),
                         @"ComponentOne Samples\Common\C1NWind.mdb") + ";";
            OleDbConnection conn = new OleDbConnection(connectionString);
            OleDbDataAdapter adapter = new OleDbDataAdapter("Select * from Data", conn);
            adapter.Fill(dt);

            BindingSource bs = new BindingSource();
            bs.DataSource = dt;

            textBox1.DataBindings.Add("Text", bs, "Company");

            c1SpellChecker1.ContextMenuCreated += C1SpellChecker1_ContextMenuCreated;
        }

        private void C1SpellChecker1_ContextMenuCreated(object sender, C1.Win.C1SpellChecker.ContextMenuEventArgs e)
        {
            var spellingItem = e.Menu.Items.Cast<ToolStripItem>().FirstOrDefault(x=> x.Name == "_mnSpell");
            if (spellingItem is null) return;
            e.Menu.Items.Remove(spellingItem);
            var newSpellingItem = e.Menu.Items.Add(spellingItem.Text);
            newSpellingItem.Name = spellingItem.Name;
            newSpellingItem.Image = spellingItem.Image;
            newSpellingItem.Click += NewSpellingItem_Click;
        }

        private void NewSpellingItem_Click(object sender, EventArgs e)
        {
            var item = sender as ToolStripItem;
            var parentStrip = item.GetCurrentParent() as ContextMenuStrip;
            var ctrl = parentStrip.SourceControl as TextBoxBase;
            if (ctrl is null) return;
            
            c1SpellChecker1.CheckControl(ctrl,false);
        }
    }
}
